
from pvoutput import PvOutputApi
import datetime
import requests
import json
import time

api = PvOutputApi(api_key="Place_your_api_key_here", system_id="your-system_id)

# Setup inverter
inverter_url = "http://192.168.178.98/solar_api/v1/"



while 1 :

	# Read InverterRealtimeData
	r = requests.get (inverter_url + 'GetInverterRealtimeData.cgi?Scope=Device&DataCollection=CommonInverterData')
	# with open('CommonInverterData.txt', 'wb') as request_data:
	# 	request_data.write(r.content)

	# Parse request into json
	inverter = json.loads(r.content)["Body"]["Data"]

	udc = inverter["UDC"]["Value"]
	udc2 = inverter["UDC_2"]["Value"]

	pdc = inverter["IDC"]["Value"] * udc
	pdc2 = inverter["IDC_2"]["Value"] * udc2
	pac = inverter["PAC"]["Value"]
	uac = inverter["UAC"]["Value"]


	print ("PDC String 1:", pdc)
	print ("PDC String 2:", pdc2)
	print ("PAC: ", pac)
	print ("UAC: ", uac)


	if (inverter["DeviceStatus"]["InverterState"] != "Sleeping"):

		# Read PowerFlowRealtimeData
		r = requests.get (inverter_url + 'GetPowerFlowRealtimeData.fcgi')
		# with open('PowerFlow.txt', 'wb') as request_data:
		# 	request_data.write(r.content)

		powerflow = json.loads(r.content)["Body"]["Data"]["Site"]

		P_Grid = powerflow["P_Grid"]
		P_Load = powerflow["P_Load"]
		P_PV = powerflow["P_PV"]
		print ("P_Grid: ", P_Grid)
		print ("P_Load: ", P_Load)
		print ("P_PV: ", P_PV)


		if (pdc+pdc2 > 0):
			InverterRatio = 100-(100/(pdc+pdc2))*pac
		else:
			InverterRatio = 0
		print ("InverterRatio: ", InverterRatio)

		# calculate StringRatio
		if (pdc2 != 0):
			StringRatio = pdc/pdc2
		else:
			StringRatio = 0
			
		# Call every 5, 10 or 15 minutes with new data
		api.update_status(power_generation=pac, power_consumption=-P_Load, ext1=StringRatio, ext2=pdc, ext3=pdc2, ext4=InverterRatio, voltage=udc+udc2)

	time.sleep(3)

	print ("----------------")

		
